import { J as Json, O as ObjectStorage, L as LogHandlerOptions, d4 as LogMessage, a as LogHandler } from './uuid-41c69f35.js';
export { dG as ArgumentsType, cy as AsyncMutex, cT as AsyncReturnType, _ as BinInput, d as CRYPTO_DEFAULT_ALG, e as CRYPTO_DEFAULT_DERIVE_ALG, f as CRYPTO_DEFAULT_DERIVE_ITERATIONS, C as CRYPTO_DEFAULT_HASH_ALG, de as Channel, dd as ChannelMessageEvent, dt as CryptoEncoder, ay as DAY_MS, aX as Day, aA as DayInput, aW as DayInputLegacy, az as DayValue, b1 as DecimalInput, b0 as DecimalValue, dk as DefaultListener, co as Disposable, cn as Disposer, cm as DisposerFunction, dl as Emitter, di as EmitterAllHandler, dh as EmitterHandler, dq as Encoder, bq as FilterFunction, J as Json, ds as JsonEncoder, dj as ListenerSignature, df as LocalChannel, a as LogHandler, L as LogHandlerOptions, d1 as LogLevel, d2 as LogLevelAlias, d3 as LogLevelAliasKey, b as LogLevelAliasType, d4 as LogMessage, d0 as Logger, d7 as LoggerConsoleHandler, d6 as LoggerContext, d5 as LoggerContextInterface, c as LoggerInterface, dc as LoggerMemoryHandler, br as MapperFunction, e0 as MemStorage, d$ as MemStorageOptions, dw as Message, du as MessageAction, dA as MessageDefinitions, dB as MessageHub, dv as MessageResult, dy as MessagesDefaultMethods, dz as MessagesMethods, dx as MessagesOptions, cx as Mutex, e4 as NestedArray, dr as NoopEncoder, O as ObjectStorage, cH as Pool, cD as PoolTask, cF as PoolTaskEvents, cB as PoolTaskFn, cE as PoolTaskIdConflictResolution, cC as PoolTaskState, bb as Primitive, dE as PubSub, dJ as RPCFn, dI as RPCOptions, dK as RPCReturn, au as RenderMessagesOptions, dH as ReturnType, bQ as RoundingMode, cW as SerialQueue, b$ as SortableItem, cV as TaskEvents, cU as TaskFn, ae as Uint8ArrayToHexDump, ad as Uint8ArrayToJson, a2 as Uint8ArrayToString, ct as UseDefer, cq as UseDispose, cl as XRX, a0 as _decodeUtf8Polyfill, $ as _encodeUtf8Polyfill, M as arrayAvg, N as arrayBatches, y as arrayEmptyInPlace, w as arrayFilterInPlace, q as arrayFlatten, s as arrayIntersection, B as arrayIsEqual, H as arrayMax, I as arrayMin, o as arrayMinus, G as arrayRandomElement, u as arrayRemoveElement, v as arraySetElement, E as arrayShuffle, F as arrayShuffleForce, D as arrayShuffleInPlace, z as arraySorted, A as arraySortedNumbers, K as arraySum, t as arraySymmetricDifference, x as arrayToggleInPlace, p as arrayUnion, n as arrayUnique, bD as avg, bB as between, cf as cloneJsonObject, ce as cloneObject, bM as cmp, bL as composeOrderby, P as createArray, dg as createLocalChannelPair, cI as createPromise, dC as createPromiseProxy, l as csvParse, m as csvParseToObjects, k as csvStringify, a$ as dateStringToDays, a_ as day, aD as dayDay, aT as dayDiff, aH as dayFromAny, aJ as dayFromDate, aK as dayFromDateGMT, aO as dayFromParts, aP as dayFromString, aM as dayFromTimestamp, aG as dayFromToday, aV as dayIterator, aC as dayMonth, aQ as dayMonthStart, aS as dayOffset, aU as dayRange, aF as dayToDate, aI as dayToDateGMT, aE as dayToParts, aN as dayToString, aL as dayToTimestamp, aB as dayYear, aR as dayYearStart, cY as debounce, b2 as decimal, b5 as decimalCentsPart, b3 as decimalFromCents, b4 as decimalToCents, U as decodeBase16, R as decodeBase32, W as decodeBase58, Y as decodeBase62, j as decrypt, b6 as deepEqual, b8 as deepMerge, b7 as deepStripUndefinedInPlace, h as deriveKeyPbkdf2, dX as detect, g as digest, cd as empty, T as encodeBase16, Q as encodeBase32, V as encodeBase58, X as encodeBase62, c7 as encodeQuery, i as encrypt, c1 as endSortWeight, c9 as ensureKey, ca as ensureKeyAsync, ab as equalBinary, b9 as escapeHTML, bP as escapeRegExp, Z as estimateSizeForBase, dO as fetchBasic, dP as fetchJson, dT as fetchOptionsBasicAuth, dR as fetchOptionsFormURLEncoded, dS as fetchOptionsJson, dQ as fetchText, ax as fixBrokenUth8String, aY as forEachDay, ci as forTimes, av as formatMessages, e2 as formatMilliseconds, a9 as fromBase64, aa as fromBase64String, ai as fromCamelCase, a6 as fromHex, dW as getGlobal, cZ as getGlobalContext, dm as getGlobalEmitter, c$ as getGlobalLogger, d8 as getNamespaceFilterString, dV as getNavigator, bw as getSecureRandom, bx as getSecureRandomIfPossible, e1 as getTimestamp, dU as getWindow, dM as httpMethod, cK as immediate, be as isArray, bk as isBoolean, dY as isBrowser, bS as isEven, bR as isHalf, bi as isInteger, c_ as isLocalHost, bl as isNullOrUndefined, bh as isNumber, bc as isObject, bF as isPrime, bE as isPrimeRX, bd as isPrimitive, cR as isPromise, bf as isRecord, bj as isSafeInteger, bg as isString, cO as isTimeout, bm as isUint8Array, a4 as joinToUint8Array, bp as jsonStringify, bo as jsonStringifySafe, bn as jsonStringifySorted, ac as jsonToUint8Array, cc as last, dp as lazyListener, c5 as linkifyPlainText, bu as listDistinctUnion, bt as listGroupBy, bv as listOfKey, bs as listQuery, cg as memoize, ch as memoizeAsync, dn as messages, c2 as moveSortWeight, bJ as objectIsEmpty, bH as objectMap, bI as objectMergeDisposable, dN as parseBasicAuth, e3 as parseDate, da as parseLogLevel, bK as parseOrderby, c8 as parseQuery, dZ as platform, cS as promisify, eq as qid, by as randomBoolean, bA as randomFloat, bz as randomInt, r as randomUint8Array, ck as regExpEscape, cj as regExpString, aw as renderMessages, bU as roundDown, bX as roundHalfAwayFromZero, bY as roundHalfDown, bZ as roundHalfEven, bW as roundHalfOdd, b_ as roundHalfTowardsZero, bV as roundHalfUp, bT as roundUp, bG as seededRandom, ek as setUuidDefaultEncoding, cb as size, cJ as sleep, c3 as sortedItems, bN as sortedOrderby, c0 as startSortWeight, aj as stringToBoolean, al as stringToFloat, ak as stringToInteger, a1 as stringToUInt8Array, eg as suid, ef as suidBytes, ei as suidBytesDate, eh as suidDate, bC as sum, cX as throttle, cM as timeout, cL as timeoutReached, cN as timoutError, a7 as toBase64, a8 as toBase64Url, at as toBool, af as toCamelCase, ag as toCapitalize, ah as toCapitalizeWords, aq as toFloat, a5 as toHex, c6 as toHumanReadableUrl, ar as toInt, as as toString, a3 as toUint8Array, bO as toValidFilename, aZ as today, cP as tryTimeout, ep as uname, ba as unescapeHTML, cA as useAsyncMutex, S as useBase, cs as useDefer, cp as useDispose, cr as useDisposer, cw as useEventListener, d_ as useExitHandler, cv as useInterval, db as useLevelFilter, dD as useMessageHub, cz as useMutex, d9 as useNamespaceFilter, cG as usePool, dF as usePubSub, dL as useRPC, c4 as useSorted, cu as useTimeout, el as uuid, ej as uuid32bit, e9 as uuidB32, e6 as uuidB62, e5 as uuidBytes, em as uuidDecode, eb as uuidDecodeB32, e8 as uuidDecodeB62, ee as uuidDecodeV4, en as uuidEncode, ea as uuidEncodeB32, e7 as uuidEncodeB62, ed as uuidEncodeV4, eo as uuidIsValid, ec as uuidv4, am as valueToBoolean, ao as valueToFloat, an as valueToInteger, ap as valueToString, cQ as waitOn } from './uuid-41c69f35.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

interface csvOptions {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
}
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): any[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

export { FileStorage, FileStorageOptions, LoggerFileHandler, LoggerNodeHandler, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
